/*
 * sobald s[i] oder w[i] geaendert wird -> e=e+de(s,w) berechnen!
 */
/* this programm needs ANSI-terminal */
#include <stdlib.h>         
#include <stdio.h>
#include <math.h>

#define version_string "0.1.1 03/03/1999"

typedef double zahl;
#define Nx  75l      /* 10 */
#define Ny  50l      /* 13 */
#define Num (Nx*Ny)
#define Max(x,y) (((x)<(y))?(y):(x))
#define Min(x,y) (((x)<(y))?(x):(y))

signed char s[Num],s2[Num];int e;
/* signed char */
short int w[Num*Num];

int hex8(zahl r)
{ unsigned char *s2;int i; s2=(unsigned char *)&(r);
  for(i=0;i<sizeof(zahl);i++) { printf("%02x",(int)s2[i]); } return(0);
}
void cls(){printf("\033[2J");}                        /* bs loeschen */
void gxy(int x,int y){printf("\033[%d;%dH",y,x);}     /* cursor bewegen */
void sbs(){printf("\033[s");}                         /* bs speichern */
void lbs(){printf("\033[u");}                         /* bs laden */
void col(int f,int b)
    {printf("\033[3%d;%d;4%dm",f & 7,(f>>3),b);} /* new color 0..7 */

void printstate()
{ long i,j;
  for(i=0l;i<Min(14l,Ny);i++)
  { gxy(1,i+1);for(j=0l;j<Min(58l,Nx);j++)
    if(s[i*Nx+j]<0)printf(".");else
    if(s[i*Nx+j]>0)printf("#");
  }
  fflush(stdout);
  for(e=0,i=0l;i<Num-1;i++)
  for( j=i+1l;j<Num;j++)e-=w[i*Num+j]*s[i]*s[j];
  gxy(5,16);printf("Energie:%8d",e);
  fflush(stdout);
}

void learn()
{ long i,j;
  for(i=0l;i<Num-1;i++)
  for(j=i+1;j<Num; j++)w[i*Num+j]+=s[i]*s[j];
}

void step()
{ long i,j,v;
  for(i=0l;i<Num;i++)
  { v=0;for(j=0l;j<Num;j++)
    if(i<j)v-=w[i*Num+j]*s[j];else
    if(j<i)v-=w[j*Num+i]*s[j];
    if(s[i]*v>0)s2[i]=-s[i];else s2[i]=s[i];
  }
  for(i=0l;i<Num;i++)s[i]=s2[i];
}

void loadfig(char *ss)
{ long i,j;char cc[300];FILE *f2;
  for(i=0l;i<Ny;i++)
  for(j=0l;j<Nx;j++) s[i*Nx+j]=-1;
  if( !(f2=fopen(ss,"r")) ){ perror("error fopen"); return; }
  for(i=0l;i<Ny;i++)
  { cc[0]=0; fgets(cc,300,f2); if(cc[0]==0) break;
    for(j=0l;j<Nx;j++)
    if(cc[j]=='#') s[i*Nx+j]=1; else
    if(cc[j]==0  ) break;
  } 
  fclose(f2);
}    

void writefig(char *ss){
  long i,j;FILE *f2;
  if((f2=fopen(ss,"w+"))==NULL){ perror("error fopen"); return; }
  for(i=0l;i<Ny;i++){
    for(j=0l;j<Nx;j++)
    if(s[i*Nx+j]<0)fprintf(f2,".");else
    if(s[i*Nx+j]>0)fprintf(f2,"#");
    fprintf(f2,"\n");
  } fclose(f2);
}


int main()
{ char c[30];int i,i1;long j;FILE *f1;
  for(j=0l;j<Num;j++)s[j]=-1;e=0;
  for(j=0l;j<Num*Num;j++)w[j]=0;
  cls();
#ifdef unix  
  /* system("ls -al>tmp~"); */
  system("ls -1 *.fig >tmp1");
#else  
  system("set dircmd=|dir /L *.fig >tmp1"); /* TC 2.0 - DOS */
#endif
  f1=fopen("tmp1","r");for(i=1;i<20;i++)if(!feof(f1))
  {gxy(60,i);if(fgets(c,20,f1)!=NULL)printf("%s",c);};fclose(f1);
  c[0]=0;
  while(c[0]!='q')
  { if(c[0]=='m')learn();
    if(c[0]=='s')step();
    if(c[0]=='z'){ sscanf(&c[1],"%d",&i);
                   printf("%d%%\n",i);fflush(stdout);
                   for(j=0l;j<Num*i/100l;j++)s[rand() % Num]*=(-1);}
    if(c[0]=='r'){ sscanf(&c[1],"%d",&i1);for(i=0;i<i1;i++){
                    for(j=0l;j<Num;j++)s[j]=1-(rand() % 2)*2;learn();
                    gxy(1,22);printf(">%5d \n",i1-i);fflush(stdout);}}
    if(c[0]=='l')loadfig(&c[1]);
    if(c[0]=='w')writefig(&c[1]);
    if(c[0]=='a'){
      f1=fopen("ising.pg1","r");for(i=1;i<20;i++)if(!feof(f1))
      { if(fgets(c,20,f1)!=NULL)
        { for(j=0;j<20;j++)if(c[j]=='\n')c[j]=0;
          loadfig(&c[0]);printstate();learn();
        }
      };
      fclose(f1);
    }
    printstate();
    gxy(1,18);printf("l<fig>=load/ figur laden      q=quit/ende    m=learn/lernen");
    gxy(1,19);printf("w<fig>=write/figur speichern  s=step/schritt a=all -> ising.pg1");
    gxy(1,20);printf("z<n>  =n%% verrauschen         r<n>= n zufallsmuster lernen");
    gxy(1,22);printf(">                \n");
    gxy(1,22);printf(">");fgets(c,29,stdin);
    gxy(1,23);printf("                                                   \r");
    fflush(stdout);
    for( i=0; i<30 && c[i]!=0; i++) if( c[i]=='\n' ) c[i]=0;
  };
  return 0;
}
